package com.blizzard.test;

import java.io.*;
import java.net.*;



public class NathansWebServer {
	private static int serverPortNumber = 80;
	private static int numberOfSockets = 5;

	public static int HTTPSTATUSCODE_OK = 200;
	public static int HTTPSTATUSCODE_FILE_NOT_FOUND = 404;
	public static int HTTPSTATUSCODE_UNAUTHORIZED = 401;
	
	public static void main (String[] args){
		/*for (String s: args){
			System.out.println(s);
			
		}*/
		System.out.println("Nathan's Web Server is starting up!");
		
		ServerSocket serverSocket = null;
		try{
			serverSocket = new ServerSocket(serverPortNumber, numberOfSockets);
		}catch(IOException e){
			System.out.println("Could not listen on port: " + serverPortNumber + " (" + e.getMessage() + ")");
			System.exit(-1);
		}
		
		Socket clientSocket = null;
		
		BufferedReader in = null;
		
		String inLine, receivedMessage = "";
		
		SimpleServletRequest request = null;
		SimpleServlet servlet = new SimpleServletImpl();
		SimpleServletResponse response = null;

		while(true){
			try{
				clientSocket = serverSocket.accept();
				
				in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
				
				inLine = in.readLine();
				while(inLine != null){
					if(inLine.contains("GET")){
						System.out.println(inLine);
					}
					receivedMessage += inLine + "\r\n";
					
					if(in.ready()){
						inLine = in.readLine();
					}else{
						inLine = null;
					}
				}

				request = new SimpleServletRequestImpl(receivedMessage.split("[\r\n]{1,}"));
				response = new SimpleServletResponseImpl(clientSocket.getOutputStream());
				servlet.doGet(request, response);
				receivedMessage = "";

			}catch(IOException e){
				System.out.println("Accept failed while listening on port " + serverPortNumber + ".");
				System.exit(-1);
			}
			
		}
		
	}
}
