package com.blizzard.test;

import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class SimpleServletImpl implements SimpleServlet{

	private ScheduledThreadPoolExecutor pool;
	private static int minNumberOfThreadsInPool = 5;
	private static int maxNumberOfThreadsInPool = 25;
	private static int poolThreadKeepAliveTime = 30000;
	
	public SimpleServletImpl(){
		this.pool = new ScheduledThreadPoolExecutor(SimpleServletImpl.minNumberOfThreadsInPool);
		this.pool.setMaximumPoolSize(SimpleServletImpl.maxNumberOfThreadsInPool);
		this.pool.setKeepAliveTime(SimpleServletImpl.poolThreadKeepAliveTime, TimeUnit.MILLISECONDS);
	}

	@Override
	public void doGet(SimpleServletRequest request,
			SimpleServletResponse response) {
		
		Runnable thread = new SimpleServletThreadImpl(request, response);
		
		pool.execute(thread);
		System.out.println("Number of active tasks: " + pool.getActiveCount());
		System.out.println("Number of completed tasks: " + pool.getCompletedTaskCount());
	}
}
