package com.blizzard.test;

import java.io.OutputStream;
import java.util.HashMap;
import java.util.Map;

public class SimpleServletResponseImpl implements SimpleServletResponse {
	private int statusCode;
	private Map<String, String> headers;
	private String mimeType;
	private OutputStream outputStream;
	
	public SimpleServletResponseImpl(){
		headers = new HashMap<String, String>();
	}
	
	public SimpleServletResponseImpl(OutputStream strm){
		this.outputStream = strm;
		headers = new HashMap<String, String>();
	}
	
	@Override
	public void setStatusCode(int httpStatusCode) {
		this.statusCode = httpStatusCode;
	}

	@Override
	public void setHeader(String name, String value) {
		headers.put(name, value);
	}

	@Override
	public void setMimeType(String mimeType) {
		this.mimeType = mimeType;
	}

	@Override
	public OutputStream getOutputStream() {
		return this.outputStream;
	}

	@Override
	public int getStatusCode() {
		return statusCode;
	}

	@Override
	public String getHeader(String name) {
		if(headers.containsKey(name)){
			return headers.get(name);
		}else{
			return null;
		}
	}

	@Override
	public String getMimeType() {
		return mimeType;
	}

}
