package com.blizzard.test;

import java.util.concurrent.ScheduledThreadPoolExecutor;

import org.junit.Test;

public class SimpleServletThreadImplTest {

	
	@Test
	public void testThreadSpammyTest() {
		
		String[] headers = new String[2];
		headers[0] = "GET /bg-top.jpg HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		Runnable testClass = new SimpleServletThreadImpl(request, response);
		
		ScheduledThreadPoolExecutor pool = new ScheduledThreadPoolExecutor(10);
		
		for(int x=0; x<1000; x++){
			System.out.println("x: " + x);
			if(pool.getActiveCount() < pool.getMaximumPoolSize()){
				pool.execute(testClass);
			}else{
				x--;
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					pool.shutdown();
					x = 1000;
				}
			}
		}
		pool.shutdown();
		
	}
	
	@Test
	public void testDoGetBadFile(){
		String[] headers = new String[2];
		headers[0] = "GET /images/layout/bg-top.jpg HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		
//		for(int x = 0; x<100; x++){
			testClass.doGet(request, response);
//		}
	}
	
	
	@Test
	public void testDoGetDirectory() {
		
		String[] headers = new String[2];
		headers[0] = "GET / HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		
		testClass.doGet(request, response);
	}

	@Test
	public void testDoGetHtml() {
		
		String[] headers = new String[2];
		headers[0] = "GET /index.html HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		
		testClass.doGet(request, response);
	}
	
	@Test
	public void testDoGetCss() {
		
		String[] headers = new String[2];
		headers[0] = "GET /bnet.css HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		testClass.doGet(request, response);
	}
	
	
	@Test
	public void testDoGetPNG() {
		
		String[] headers = new String[2];
		headers[0] = "GET /blizz.png HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		testClass.doGet(request, response);
	}
	
	@Test
	public void testDoGetJpg() {
		
		String[] headers = new String[2];
		headers[0] = "GET /bg-top.jpg HTTP/1.1";
		headers[1] = "Host: localhost";
		
		SimpleServletRequest request = new SimpleServletRequestImpl(headers);
		SimpleServletResponse response = new SimpleServletResponseImpl(System.out); // accepts output stream
		
		SimpleServletThreadImpl testClass = new SimpleServletThreadImpl(request, response);
		

		testClass.doGet(request, response);
		
	}
}
